
#include "menu/eli-core-module.lua"

sctl = {'(Master Set / Pre-Distribution Master)','(Tester Set / Pre-Distribution Play Copy)','(Pre-Distribution Beta Copy)','(Release / Distribution Copy)'}
function round(num, numDecimalPlaces)
	local mult = 10^(numDecimalPlaces or 0)
	return math.floor(num * mult + 0.5) / mult
  end

  function Round(to_round)
    local divided = to_round / 5
    local rounded = 5 * math.floor(divided)
    return rounded
end
function init() 
    shapes = FindShapes("",true)
    lights = FindLights("",true)
    currentSecond = 0
    currentHour = 0
    currentMinute = 0
    displayfps = 0
    lastnum = 0
    metaenabled = GetBoolParam("meta", false)
    beta = GetBoolParam("beta", false)
    scn = GetStringParam("sc", 'RDC015') 
    sct = GetIntParam("sct", 4)
    lastkey = ""
end

-- SC LIST (Serialized Copy)
--
-- MES (Master Edit Set)
-- MES001: Eli
-- MES002: Matt Faulk
--
-- BPTC (Beta Play Test Copy)
-- BPTC003: Ken Anderson
-- BPTC003: Brianna
-- BPTC005: Ceze
-- BPTC006: Francisco Melard
--
-- PMPC (Promotional Media Play Copy)
-- PMPC007: Crash
-- PMPC008: Drew
-- PMPC009: Len
-- PMPC010: **
-- PMPC011: Cartel
-- PMPC012: TDIG
-- PMPC013: TDTT
--
-- RDC (Release Distribution Copy)
-- RDC014: -1 Hour Release
-- RDC015: ***END USER***






function tick(dt) 
    if metaenabled == true then

    fps = round(1 / dt, NUM_DECIMAL_FIGURES)
    fpsn = 1 / fps 
    currentSecond = currentSecond + fpsn

    lastkey = InputLastPressedKey()

        if lastkey == "W" then
            lastkeyd = "W (Forward)"
        elseif lastkey == "S" then
            lastkeyd = "S (Backward)"
        elseif lastkey == "A" then
            lastkeyd = "A (Left)"
        elseif lastkey == "D" then
            lastkeyd = "D (Right)"
        elseif lastkey == "space" then
            lastkeyd = "SPACE (Jump)"
        elseif lastkey == "ctrl" then
            lastkeyd = "CTRL (Crouch)"
        elseif lastkey == "E" then
            lastkeyd = "E (Interact)"
        elseif lastkey == "" then
            -- nothing
        elseif lastkey == "tab" then
            lastkeyd = "TAB (Map)"
        else
            lastkeyd = lastkey
        end

    if currentSecond >= 60 then
		currentSecond = 0
		currentMinute = currentMinute + 1
	end
	if currentMinute >= 60 then
		currentMinute = 0
		currentHour = currentHour + 1
	end

    newnum = tonumber(string.format("%02d", currentSecond))
    if newnum ~= lastnum then
        displayfps = fps
    end
    lastnum = tonumber(string.format("%02d", currentSecond))

    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    DebugPrint(" ")
    if beta == true then 
        DebugPrint("BETA COPY: " .. mod.data.name)
    else
        DebugPrint("RELEASE COPY: " .. mod.data.name)
    end
    DebugPrint("---------------------------------")
    DebugPrint("FPS     : " .. displayfps .. " Unstable: " .. fps)
    DebugPrint("Shapes  : " .. #shapes .. " Lights: " .. #lights)
    DebugPrint("Night   : " .. tostring(GetEnvironmentProperty("nightlight")))
    DebugPrint("TDV     : " .. GetVersion() .. " MOD VERSION: " .. mod.data.version)
    DebugPrint("Position: " .. "X " .. string.format("%00.2f",GetPlayerTransform().pos[1]) .. ", " .. "Y " .. string.format("%00.2f",GetPlayerTransform().pos[2]) .. ", " .. "Z " .. string.format("%00.2f",GetPlayerTransform().pos[3]))
    DebugPrint("Playtime: " .. string.format("%02d", currentHour) .. ":" .. string.format("%02d", currentMinute) .. ":" .. string.format("%02d", currentSecond))
    DebugPrint("Last Key: " .. tostring(lastkeyd))
    if #shapes > 1500 then
        DebugPrint("ASSETS  : PASS")
    else 
        DebugPrint("ASSETS  : FAIL")
    end
    DebugPrint("SCRIPTS : PASS")
    DebugPrint("---------------------------------")
    DebugPrint("DO NOT DISTRIBUTE - DO NOT SHARE")
    DebugPrint("SC: " .. scn .. " " .. sctl[sct])
end
end